unit Unit6;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Series, TeeTools, TeeGDIPlus, ExtCtrls, TeeProcs, TeEngine, Chart,
  TeeEdit, StdCtrls,TeeFunci,StatChar, OHLChart, CandleCh, Grids, TeeChartGrid,
  TeeNavigator;

type
  TForm6 = class(TForm)
    Chart1: TChart;
    ChartEditor1: TChartEditor;
    Panel1: TPanel;
    Button1: TButton;
    edtSeries: TEdit;
    Label1: TLabel;
    ChartGrid1: TChartGrid;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
     tmpLineSeries:TLineSeries;
     tmpAxis      : TChartAxis;
     tmpMyCandle  : TCandleSeries;
     stockHastic  : TStochasticFunction;
     ChartTool1   : TAnnotationTool;
     MaxCloseAnnot: TAnnotationTool;
     MouseCloseAnnot: TAnnotationTool;
     Years   : TChartAxis;
     tmpStockhastic:TLineSeries;

     procedure calculateaxes;
     procedure calculateAnnotations;
     procedure calculateAxesAnnotations;
     procedure SetAnnotationPosition(Annotation: TAnnotationTool; index: Integer=-1);
     procedure createstockhastic(candleSeries :TCandleSeries );

    function InterpolateLineSeries(Series: TChartSeries;XValue: Double): Double; overload;
    function InterpolateLineSeries(Series: TChartSeries; FirstIndex,
                                  LastIndex: Integer; XValue: Double): Double; overload;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form6: TForm6;



implementation

{$R *.dfm}

procedure TForm6.Button1Click(Sender: TObject);
begin
   createstockhastic(tmpMyCandle);
end;

procedure TForm6.Chart1DblClick(Sender: TObject);
begin
   ChartEditor1.Execute;
end;

procedure TForm6.Chart1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Index,IndexLine : Integer;
    xval , stock , yval: Double;
    tmpDateStr: String;
    tmpDate: TDateTime;
  I: Integer;
begin
  Index:=tmpMyCandle.Clicked(X, Y);
  MouseCloseAnnot.Active:=Index<>-1;
  xval := Chart1.Axes.Bottom.CalcPosPoint(X);
  Label2.Caption := DateTimeToStr(xval);


  {WHAT I WANT TO TRY AND ACCOMPLISH

   1) At tis stage I have my x value of date
   2) Without moving the mouse over my Candle OR LineSeries, I
      want to return the matching Y VALUE MATCHING the X VALUE
   3) I want something like a string grid routine
   4) Example

   for I := 0 to stringgrid.columns.count - 1 do
     for X := 0 to stringgrid.rows.count - 1 do
         if DateTimeToStr(xval) = series[1].Yvalue then
            MATCH


  }

  Label3.Caption:='';
  Label4.Caption:='';
  if Chart1.Axes.Bottom.Texts.Selected.HoverIndex <> -1 then
  begin
    if (xval>=tmpStockhastic.XValues.MinValue) and (xval<=tmpStockhastic.XValues.MaxValue) then
    begin
      yval:=InterpolateLineSeries(tmpStockhastic,xval);
      Label3.Caption:='Interpolated YValue: ' + FloatToStrF(yval, ffNumber, 8, 2);

      for IndexLine := 0 to tmpStockhastic.Count-1 do
        if tmpStockhastic.CalcXPos(IndexLine) = X then
        begin
          Label3.Caption:=Label3.Caption + ' - EXACT MATCH!';
          break;
        end;
    end;

    tmpDateStr:=Chart1.Axes.Bottom.Items[Chart1.Axes.Bottom.Texts.Selected.HoverIndex].Text;
    Label4.Caption:='Axis label under mouse: ' + tmpDateStr;
    tmpDate:=StrToDateTimeDef(tmpDateStr, 0);
    if (tmpDate<>0) then
      for IndexLine := 0 to tmpStockhastic.Count-1 do
        if tmpStockhastic.XValue[IndexLine] = tmpDate then
        begin
          Label4.Caption:=Label4.Caption + ' - with YValue: ' + FormatFloat('#,##0.###', tmpStockhastic.YValue[IndexLine]);
          break;
        end;

  end;

  If MouseCloseAnnot.Active then
  begin
    MouseCloseAnnot.Text:=FloatToStr(tmpMyCandle.CloseValues[Index]);
    SetAnnotationPosition(MouseCloseAnnot);
    label1.Caption := 'Open Value '+FormatFloat('###',tmpMyCandle.OpenValues[Index]) +' DATE  '+DateTimeToStr(tmpMyCandle.DateValues[Index]);
  end;

end;

function TForm6.InterpolateLineSeries(Series: TChartSeries;
  XValue: Double): Double;
begin
  result:=InterpolateLineSeries(Series,Series.FirstDisplayedIndex,Series.LastValueIndex,XValue);
end;

function TForm6.InterpolateLineSeries(Series: TChartSeries;
  FirstIndex, LastIndex: Integer; XValue: Double): Double;
var
  Index: Integer;
  dx,dy: Double;
begin
  for Index:=FirstIndex to LastIndex do
    if Series.XValues.Value[Index]>XValue then break;

  //safeguard
  if (Index<1) then Index:=1
  else if (Index>=Series.Count) then Index:=Series.Count-1;

  // y=(y2-y1)/(x2-x1)*(x-x1)+y1
  dx:=Series.XValues.Value[Index] - Series.XValues.Value[Index-1];
  dy:=Series.YValues.Value[Index] - Series.YValues.Value[Index-1];

  if (dx<>0) then
    result:=dy*(XValue - Series.XValues.Value[Index-1])/dx + Series.YValues.Value[Index-1]
  else result:=0;
end;

procedure TForm6.calculateAxesAnnotations;
begin
  calculateaxes;
  Chart1.Draw;
  calculateAnnotations;
end;

procedure TForm6.calculateaxes;
var i, n: Integer;
begin
  n:=Chart1.CustomAxes.Count+1;
  Chart1.Axes.Left.StartPosition := 0;
  Chart1.Axes.Left.EndPosition   := 100/n;

   for i:=Chart1.CustomAxes.count -1 downto 0 do
   begin
      Chart1.CustomAxes[i].StartPosition := (i+1)*120/n;
      Chart1.CustomAxes[i].EndPosition   := (i+2)*100/n;
   end;
end;

procedure TForm6.calculateAnnotations;
var i, YPos: Integer;
    Value: Double;
begin
   for i:=Chart1.CustomAxes.Count-1 downto 0 do
     SetAnnotationPosition(Chart1.Tools.Items[i+2] as TAnnotationTool, i);

   SetAnnotationPosition(MaxCloseAnnot);
end;

procedure TForm6.SetAnnotationPosition(Annotation: TAnnotationTool; index: Integer=-1);
var YPos: Integer;
    Value: Double;
begin
   with Annotation do
   begin
     Value:=StrToFloat(Text);

     if (index>-1) then
       YPos:=Chart1.CustomAxes.Items[index].CalcPosValue(Value) - (Height div 2)
     else
       YPos:=Chart1.Axes.Left.CalcPosValue(Value) - (Height div 2);

     Shape.CustomPosition:=true;
     Shape.Left:=Chart1.ChartRect.Left-50;
     Shape.Top:=YPos;
   end;
end;

procedure TForm6.FormCreate(Sender: TObject);
var i: Integer;

begin
   for i:= Chart1.SeriesList.Count-1 downto 0 do
   begin
     Chart1.RemoveSeries(Chart1[I]);
   end;

   if Chart1.Axes.Bottom.SubAxes.Count > 0 then
   begin
     for i:=  Chart1.Axes.Bottom.SubAxes.Count-1 downto 0 do
     begin
        Chart1.Axes.Bottom.SubAxes.Delete(i);
     end;
   end;

   Chart1.View3D:=false;
   Chart1.MarginLeft:=7;
   Chart1.Legend.HorizMargin:=40;

   for i:=0 to 1-1 do
   begin
     with Chart1 do
     begin
        tmpMyCandle := TCandleSeries.Create(self);

        tmpMyCandle.CandleStyle := csOpenClose;
        tmpMyCandle.Title := 'Candle' ;
        tmpMyCandle.Draw3D := False;
        tmpMyCandle.Dark3D := False;
        tmpMyCandle.DownCloseColor := clGreen;
        tmpMyCandle.DownCloseGradient.StartColor := clGreen;
        tmpMyCandle.HighLowPen.Color := clDefault;
        tmpMyCandle.Name := 'Henry';

        tmpMyCandle.UpCloseColor := clRed;
        tmpMyCandle.UpCloseGradient.StartColor := clRed ;

        tmpMyCandle.FillSampleValues(20);

        Chart1.Axes.Left.Axis.Color:=Color;
        Chart1.Axes.Left.Maximum := tmpMyCandle.CloseValues.MaxValue;
        Chart1.Axes.Left.Minimum := tmpMyCandle.CloseValues.MinValue;
        Chart1.Axes.Left.Automatic := false;
        Chart1.Axes.Left.Increment := 50;
        Chart1.Axes.Left.DisplayName := 'Henry';

        AddSeries(tmpMyCandle);
     end;
   end;

   Years:=Chart1.Axes.Bottom.SubAxes.Add;
   Years.Increment:= 7;
   Years.DateTimeFormat:='DD-MM-YY';
   Years.LabelsFont.Color := clblack;
   Years.Visible:=True;

   MaxCloseAnnot:=Chart1.Tools.Add(TAnnotationTool) as TAnnotationTool;
   MouseCloseAnnot:=Chart1.Tools.Add(TAnnotationTool) as TAnnotationTool;

   MaxCloseAnnot.Text:=FloatToStr(250);
   MaxCloseAnnot.Shape.Transparent:=True;
   MaxCloseAnnot.Shape.Font.Color:=clRed;

   MouseCloseAnnot.Active:=False;
   MouseCloseAnnot.Shape.Transparent:=True;
   MouseCloseAnnot.Shape.Font.Color:=clBlue;

   createstockhastic(tmpMyCandle);

   calculateAxesAnnotations;
end;


procedure TForm6.createstockhastic(candleSeries: TCandleSeries);
var
  I:Integer;

begin
   stockHastic := TStochasticFunction.Create(nil);

   with chart1 do
   begin
      tmpStockhastic := TLineSeries.Create(self);
      addSeries(tmpStockhastic);
      tmpStockhastic.SetFunction(stockHastic);
      tmpStockhastic.DataSources.Clear;
      tmpStockhastic.DataSources.Add( candleSeries );
      tmpStockhastic.FunctionType.Period := StrToInt(edtSeries.Text);
      tmpAxis:=Chart1.CustomAxes.Add as TChartAxis;
      tmpStockhastic.CustomVertAxis:=tmpAxis;
      tmpAxis.Axis.Color:=Color;


      ChartTool1 := TAnnotationTool.Create(nil);

      ChartTool1.Text:=FormatFloat('#0.00',(tmpStockhastic.YValue[tmpStockhastic.YValues.Count-1]));
      ChartTool1.Shape.Transparent:=True;
      ChartTool1.Shape.Font.Color:=clRed;
      Chart1.Tools.Add(ChartTool1);

      calculateAxesAnnotations;

      //ListBox1.Items.Add('stockhastic '+FormatFloat('#0.00',(tmpStockhastic.YValue[tmpStockhastic.YValues.Count-1]))) ;
   end;
end;

end.
